document.addEventListener("DOMContentLoaded", function () {

	const photoButton = document.getElementById('photo-button');
	const fileInput = document.getElementById('file-input');

	photoButton.classList.add('animated');

	fileInput.addEventListener('change', e => {
		const file = fileInput.files[0];

		photoButton.classList.add('uploading');
		transformImage(file, { canvas: true, maxWidth: 1920 }).then(canvas => {
			canvas.toBlob(blob => {
				let formData = new FormData();
				formData.append("file", blob);
				formData.append("target", "upload");
				formData.append("fileName", "*.png");

				let xhr = new XMLHttpRequest();
				xhr.onreadystatechange = () => {
					if (xhr.readyState === 4 && xhr.status === 200) {
						let tempPath = xhr.responseText;
						xhr = new XMLHttpRequest();
						xhr.onreadystatechange = () => {
							if (xhr.readyState === 4 && xhr.status === 200) {
								photoButton.classList.remove('uploading');
								fileInput.files = undefined;
							}
						};
						xhr.open("POST", "/rest/script/invoke/Photo/finish");
						xhr.setRequestHeader('Content-Type', 'application/json');
						xhr.send(JSON.stringify({
							tempPath: tempPath
						}));
					}
				};
				xhr.open("POST", "/rest/upload/multipart");
				xhr.send(formData);
			}, 'image/jpeg', 1);
		});
	});

	function getImageOrientation(file) {
		return new Promise((resolve, reject) => {
			try {
				loadImage.parseMetaData(
					file,
					data => resolve(data.exif ? data.exif.get('Orientation') : 0),
					{ isTableImageHead: true }
				);
			} catch (ex) {
				reject();
			}
		});
	}

	function transformImage(file, options) {
		return new Promise((resolve, reject) => {
			getImageOrientation(file).then(
				orientation => {
					options['orientation'] = orientation;
					loadImage(
						file,
						resolve,
						options
					);
				},
				() => {
					reject();
				}
			);
		});
	}

});
